-- keep this in sync with the pg_similarity--x.y.sql extension install file

-- Adjust this setting to control where the objects get created.
SET search_path = public;

-- Block
CREATE OR REPLACE FUNCTION block (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'block'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION block_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'block_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~++ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = block_op,
	COMMUTATOR = '~++',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Cosine
CREATE OR REPLACE FUNCTION cosine (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'cosine'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION cosine_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'cosine_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~## (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = cosine_op,
	COMMUTATOR = '~##',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Dice
CREATE OR REPLACE FUNCTION dice (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'dice'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION dice_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'dice_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~-~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = dice_op,
	COMMUTATOR = '~-~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Euclidean
CREATE OR REPLACE FUNCTION euclidean (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'euclidean'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION euclidean_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'euclidean_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~!! (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = euclidean_op,
	COMMUTATOR = '~!!',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Hamming
CREATE OR REPLACE FUNCTION hamming (varbit, varbit) RETURNS float8
AS '$libdir/pg_similarity','hamming'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION hamming_op (varbit, varbit) RETURNS bool
AS '$libdir/pg_similarity', 'hamming_op'
LANGUAGE C STABLE STRICT;

CREATE OR REPLACE FUNCTION hamming_text (text, text) RETURNS float8
AS '$libdir/pg_similarity','hamming_text'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION hamming_text_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'hamming_text_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~@~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = hamming_text_op,
	COMMUTATOR = '~@~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Jaccard
CREATE OR REPLACE FUNCTION jaccard (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'jaccard'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION jaccard_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'jaccard_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~?? (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = jaccard_op,
	COMMUTATOR = '~??',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Jaro
CREATE OR REPLACE FUNCTION jaro (text, text) RETURNS float8
AS '$libdir/pg_similarity','jaro'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION jaro_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'jaro_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~%% (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = jaro_op,
	COMMUTATOR = '~%%',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Jaro-Winkler
CREATE OR REPLACE FUNCTION jarowinkler (text, text) RETURNS float8
AS '$libdir/pg_similarity','jarowinkler'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION jarowinkler_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'jarowinkler_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~@@ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = jarowinkler_op,
	COMMUTATOR = '~@@',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Levenshtein
CREATE OR REPLACE FUNCTION lev (text, text) RETURNS float8
AS '$libdir/pg_similarity','lev'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION lev_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'lev_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~== (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = lev_op,
	COMMUTATOR = '~==',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

CREATE OR REPLACE FUNCTION levslow (text, text) RETURNS float8
AS '$libdir/pg_similarity','levslow'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION levslow_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'levslow_op'
LANGUAGE C STABLE STRICT;

--CREATE OPERATOR ~=^ (
--	LEFTARG = text,
--	RIGHTARG = text,
--	PROCEDURE = levslow_op,
--	COMMUTATOR = '~=^',
--	RESTRICT = contsel,
--	JOIN = contjoinsel
--);

-- Matching Coefficient
CREATE OR REPLACE FUNCTION matchingcoefficient (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'matchingcoefficient'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION matchingcoefficient_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'matchingcoefficient_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~^^ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = matchingcoefficient_op,
	COMMUTATOR = '~^^',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Monge-Elkan
CREATE OR REPLACE FUNCTION mongeelkan (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'mongeelkan'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION mongeelkan_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'mongeelkan_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~|| (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = mongeelkan_op,
	COMMUTATOR = '~||',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Needleman-Wunsch
CREATE OR REPLACE FUNCTION needlemanwunsch (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'needlemanwunsch'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION needlemanwunsch_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'needlemanwunsch_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~#~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = needlemanwunsch_op,
	COMMUTATOR = '~#~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Overlap Coefficient
CREATE OR REPLACE FUNCTION overlapcoefficient (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'overlapcoefficient'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION overlapcoefficient_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'overlapcoefficient_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~** (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = overlapcoefficient_op,
	COMMUTATOR = '~**',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Q-Gram
CREATE OR REPLACE FUNCTION qgram (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'qgram'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION qgram_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'qgram_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~~~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = qgram_op,
	COMMUTATOR = '~~~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Smith-Waterman
CREATE OR REPLACE FUNCTION smithwaterman (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'smithwaterman'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION smithwaterman_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'smithwaterman_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~=~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = smithwaterman_op,
	COMMUTATOR = '~=~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Smith-Waterman-Gotoh
CREATE OR REPLACE FUNCTION smithwatermangotoh (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'smithwatermangotoh'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION smithwatermangotoh_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'smithwatermangotoh_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~!~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = smithwatermangotoh_op,
	COMMUTATOR = '~!~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

-- Soundex
CREATE OR REPLACE FUNCTION soundex (text, text) RETURNS float8
AS '$libdir/pg_similarity', 'soundex'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION soundex_op (text, text) RETURNS bool
AS '$libdir/pg_similarity', 'soundex_op'
LANGUAGE C STABLE STRICT;

CREATE OPERATOR ~*~ (
	LEFTARG = text,
	RIGHTARG = text,
	PROCEDURE = soundex_op,
	COMMUTATOR = '~*~',
	RESTRICT = contsel,
	JOIN = contjoinsel
);

--
-- GIN support
--

CREATE OR REPLACE FUNCTION gin_extract_value_token(internal, internal, internal)
RETURNS internal
AS '$libdir/pg_similarity'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION gin_extract_query_token(internal, internal, int2, internal, internal, internal, internal)
RETURNS internal
AS '$libdir/pg_similarity'
LANGUAGE C IMMUTABLE STRICT;

CREATE OR REPLACE FUNCTION gin_token_consistent(internal, int2, internal, int4, internal, internal, internal, internal)
RETURNS bool
AS '$libdir/pg_similarity'
LANGUAGE C IMMUTABLE STRICT;

CREATE OPERATOR CLASS gin_similarity_ops
FOR TYPE text USING gin
AS
    OPERATOR    1   ~++,		-- block
    OPERATOR    2   ~##,		-- cosine
    OPERATOR    3   ~-~,		-- dice
    OPERATOR    4   ~!!,		-- euclidean
    OPERATOR    5   ~??,		-- jaccard
--    OPERATOR    6   ~%%,		-- jaro
--    OPERATOR    7   ~@@,		-- jarowinkler
--    OPERATOR    8   ~==,		-- lev
    OPERATOR    9   ~^^,		-- matchingcoefficient
--    OPERATOR    10  ~||,		-- mongeelkan
--    OPERATOR    11  ~#~,		-- needlemanwunsch
    OPERATOR    12  ~**,		-- overlapcoefficient
    OPERATOR    13  ~~~,		-- qgram
--    OPERATOR    14  ~=~,		-- smithwaterman
--    OPERATOR    15  ~!~,		-- smithwatermangotoh
--    OPERATOR    16  ~*~,		-- soundex
    FUNCTION    1   bttextcmp(text, text),
    FUNCTION    2   gin_extract_value_token(internal, internal, internal),
    FUNCTION    3   gin_extract_query_token(internal, internal, int2, internal, internal, internal, internal),
    FUNCTION    4   gin_token_consistent(internal, int2, internal, int4, internal, internal, internal, internal),
    STORAGE text;
